local testimtopic = ""
local proseccolor = SKINCOLOR_NONE
local prosec
local defensecolor = SKINCOLOR_NONE
local defense
local textx = 0
local barx = 0
local texty = 0

local function P_FindPlayerByNode(node)
	for p in players.iterate
		if #p == node then
			return p
		end
	end
end

COM_AddCommand("crossexamine", function(p, pro, topic, def)
	if gamestate != 1 then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if tonumber(pro) == nil or not players[tonumber(pro)] then
		CONS_Printf(p, "You need to specify a prosecutor player node.")
		return
	end
	
	if testimonyprogress then
		testimonyprogress = 0
	end
	
	if topic then
		testimtopic = topic
	else
		testimtopic = "Witness's Account"
	end
	prosec = P_FindPlayerByNode(tonumber(pro))
	proseccolor = prosec.mo.color
	if def and tonumber(def) and players[tonumber(def)] then
		defense = P_FindPlayerByNode(tonumber(def))
	else
		defense = p
	end
	defensecolor = defense.mo.color
	examinationprogress = 1
	chatprint("\x82* Commencing Cross-Examination...")
	chatprint("\x82*\x80 Testimony topic: \x87"..testimtopic)
	S_StartSound(nil, sfx_aaxmnt)
end)

addHook("MapLoad", do
	examinationprogress = 0
end)

addHook("PlayerThink", function(p)
	if gamestate != 1 then return end
	
	if examinationprogress == 12 then
		P_FlashPal(p, PAL_WHITE, TICRATE/4)
	end
end)

hud.add(function(v, p, c)
	if not examinationprogress then return end
	
	if examinationprogress == 3*TICRATE then
		S_StartSound(nil, sfx_aatrns, p)
	end
	
	if examinationprogress >= 3*TICRATE and examinationprogress <= 7*TICRATE/2 then
		barx = $+19
		texty = $+10
	elseif examinationprogress < 12
		textx = -320+examinationprogress*27
	else
		textx = 0
		texty = 0
		barx = 0
	end
	
	if examinationprogress <= 7*TICRATE/2 then
		v.draw(textx, -texty, v.cachePatch("AACROSS"))
		v.draw(-textx, texty, v.cachePatch("AAXMNTN"))
		if examinationprogress >= 12 then
			v.draw(-barx, 10, v.cachePatch("SUSPBACK"))
			v.draw(barx, 10, v.cachePatch("SUSDBACK"))
			v.draw(-barx, 10, v.getSprite2Patch(defense.mo.skin, "SUSP"), 0, v.getColormap(defense.mo.skin, defensecolor))
			v.draw(barx, 10, v.getSprite2Patch(prosec.mo.skin, "SUSD"), 0, v.getColormap(prosec.mo.skin, proseccolor))
		end
	elseif examinationprogress <= 7*TICRATE/2+3*TICRATE then
		v.drawString(160, 100, "== "..testimtopic.." ==", V_ORANGEMAP, "thin-center")
	end
	
	if examinationprogress <= 7*TICRATE/2+3*TICRATE then
		examinationprogress = $+1
	end
end, "game")