freeslot("SPR2_SUSP", "SPR2_SUSD",
"sfx_aawitn", "sfx_aaxmnt", "sfx_aatrns",
"sfx_snhold", "sfx_snobje", "sfx_sntkth",
"sfx_tlhold", "sfx_tlobje", "sfx_tltkth",
"sfx_knhold", "sfx_knobje", "sfx_kntkth",
"sfx_arhold", "sfx_arobje", "sfx_artkth",
"sfx_fnhold", "sfx_fnobje", "sfx_fntkth",
"sfx_mshold", "sfx_msobje", "sfx_mstkth")

spr2defaults[SPR2_SUSP] = SPR2_XTRA
spr2defaults[SPR2_SUSD] = SPR2_XTRA

sfxinfo[sfx_aawitn].caption = "/"
sfxinfo[sfx_aaxmnt].caption = "/"
sfxinfo[sfx_aatrns].caption = "/"
sfxinfo[sfx_snhold].caption = "/"
sfxinfo[sfx_snobje].caption = "/"
sfxinfo[sfx_sntkth].caption = "/"
sfxinfo[sfx_tlhold].caption = "/"
sfxinfo[sfx_tlobje].caption = "/"
sfxinfo[sfx_tltkth].caption = "/"
sfxinfo[sfx_knhold].caption = "/"
sfxinfo[sfx_knobje].caption = "/"
sfxinfo[sfx_kntkth].caption = "/"
sfxinfo[sfx_arhold].caption = "/"
sfxinfo[sfx_arobje].caption = "/"
sfxinfo[sfx_artkth].caption = "/"
sfxinfo[sfx_fnhold].caption = "/"
sfxinfo[sfx_fnobje].caption = "/"
sfxinfo[sfx_fntkth].caption = "/"
sfxinfo[sfx_mshold].caption = "/"
sfxinfo[sfx_msobje].caption = "/"
sfxinfo[sfx_mstkth].caption = "/"

rawset(_G, "testimonyprogress", 0)
rawset(_G, "examinationprogress", 0)
rawset(_G, "shoutprogress", 0)
rawset(_G, "shoutcooldown", 17)
rawset(_G, "shoutwarn", true)
rawset(_G, "shoutallowed", "on")
rawset(_G, "recolorcutins", true)

COM_AddCommand("recolorcutins", function(p, arg)
	if not arg then
		CONS_Printf(p, "\x82recolorcutins\x80 - Allow the witness testimony cut-in and the shout bubbles to be recolored. Boolean.")
	elseif not (arg == "off" or arg == "on" or arg == "yes" or arg == "no" or arg == "y" or arg == "n" or arg == "1" or arg == "0" or arg == "true" or arg == "false") then
		CONS_Printf(p, "Invalid argument.")
	end
	
	if (arg == "off" or arg == "no" or arg == "n" or arg == "0" or arg == "false") then
		recolorcutins = false
		CONS_Printf(p, "Cut-ins can not be recolored.")
	elseif (arg == "on" or arg == "yes" or arg == "y" or arg == "1" or arg == "true") then
		recolorcutins = true
		CONS_Printf(p, "Cut-ins can now be recolored.")
	end
end, COM_ADMIN)

COM_AddCommand("shoutcooldown", function(p, arg)
	if not arg then
		CONS_Printf(p, "\x82shoutcooldown\x80 - Set the cooldown between shouts in tics. Only accepts values between 0 and 1 second.")
		return
	elseif tonumber(arg) == nil or tonumber(arg) < 0 or tonumber(arg) > 35 then
		CONS_Printf(p, "Invalid argument.")
		return
	end
	
	shoutcooldown = tonumber(arg)
	CONS_Printf(p, "Set shout cooldown to "..arg..".")
end, COM_ADMIN)

local shoutTable = {
    sonic = {
        holdit = sfx_snhold,
        object = sfx_snobje,
        tkthat = sfx_sntkth,
    },
    tails = {
        holdit = sfx_tlhold,
        object = sfx_tlobje,
        tkthat = sfx_tltkth,
    },
    knuckles = {
        holdit = sfx_knhold,
        object = sfx_knobje,
        tkthat = sfx_kntkth,
    },
    amy = {
        holdit = sfx_arhold,
        object = sfx_arobje,
        tkthat = sfx_artkth,
    },
    fang = {
        holdit = sfx_fnhold,
        object = sfx_fnobje,
        tkthat = sfx_fntkth,
    },
    metalsonic = {
        holdit = sfx_mshold,
        object = sfx_msobje,
        tkthat = sfx_mstkth,
    },
}
rawset(_G, "skinToShout", shoutTable)