local testimtopic = ""
local testimcolor = SKINCOLOR_BLUE
local testimplayer
local textpos = 0
local barpos = 0
local playervote = 0
local playersinserver = 0

addHook("PreThinkFrame", do
	playersinserver = 0
	for p in players.iterate
		playersinserver = $+1
	end
	
	if not testimonyprogress then
		playervote = 0
	end
end)

COM_AddCommand("testify", function(p, arg)
	if gamestate != 1 then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if testimonyprogress then
		CONS_Printf(p, "You can't testify while someone else is testifying.")
		return
	end
	
	if examinationprogress then
		examinationprogress = 0
	end
	
	if arg then
		testimtopic = arg
	else
		testimtopic = "Witness's Account"
	end
	testimplayer = p
	if recolorcutins then
		testimcolor = testimplayer.mo.color
	else
		testimcolor = SKINCOLOR_BLUE
	end
	testimonyprogress = 1
	chatprint("\x82* "..testimplayer.name.." would like to testify!")
	chatprint("\x82*\x80 Testimony topic: \x87"..testimtopic)
	S_StartSound(nil, sfx_aawitn)
end)

COM_AddCommand("judgeendtestimony", function(p)
	if gamestate != 1 then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if not testimonyprogress then
		CONS_Printf(p, "Nobody is testifing right now.")
		return
	end
	
	testimonyprogress = 0
	chatprint("\x82* This is the end of "..testimplayer.name.."'s testimony.")
end, COM_ADMIN)

COM_AddCommand("endtestimony", function(p)
	if gamestate != 1 then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if not testimonyprogress then
		CONS_Printf(p, "Nobody is testifing right now.")
		return
	end
	if testimplayer == p then
		testimonyprogress = 0
		chatprint("\x82* This is the end of "..testimplayer.name.."'s testimony.")
		return
	elseif not p.voted
		playervote = $+1
		p.voted = true
		chatprint("\x82* "..p.name.." wants to end "..testimplayer.name.."'s testimony. "..playervote.."/"..playersinserver-(playersinserver/5)..".")
	end
	
	if playervote >= playersinserver-(playersinserver/5) then
		chatprint("\x82* ...! Enough players voted to end the testimony!")
		testimonyprogress = 0
		chatprint("\x82* This is the end of "..testimplayer.name.."'s testimony.")
		for pl in players.iterate
			pl.voted = false
		end
		playervote = 0
	end
end)

addHook("MapLoad", do
	testimonyprogress = 0
end)

COM_AddCommand("testimtheme", function(p, arg)
	if gamestate != 1 then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if not arg then
		CONS_Printf(p, "\x82testimtheme\x80 - Set the theme that plays during a testimony. If set to \"none\", the level music will not be interrupted, otherwise the specified music lump will play.")
		return
	end
	
	if arg == "none" then
		p.interrupttheme = false
		CONS_Printf(p, "Disabled the testimony theme.")
	else
		p.interrupttheme = true
		p.testimtheme = arg
		CONS_Printf(p, "Set the testimony theme to "..arg..".")
		p.testimplaying = false
	end
end)

addHook("PlayerThink", function(p)
	if gamestate != 1 then return end
	
	if not testimonyprogress then
		p.voted = false
	end
	
	if p.interrupttheme == nil then p.interrupttheme = true end
	if not p.testimtheme then p.testimtheme = "tnttst" end
	
	if testimonyprogress > 7*TICRATE/2+3*TICRATE and p.interrupttheme and not p.testimplaying then
		P_PlayJingleMusic(p, p.testimtheme)
		p.testimplaying = true
    end
	if testimonyprogress == 12 then
		P_FlashPal(p, PAL_WHITE, TICRATE/4)
	end
	if testimonyprogress and p.interrupttheme and not p.testimplaying then
		S_StopMusic(p)
    end
	if p.testimplaying and not testimonyprogress
		P_RestoreMusic(p)
		p.testimplaying = false
	end
end)

addHook("ShouldJingleContinue", function(p, m)
	if m == p.testimtheme
	and testimonyprogress
		return true
	end
end)

hud.add(function(v, p, c)
	if not testimonyprogress then return end
	
	if testimonyprogress == 3*TICRATE then
		S_StartSound(nil, sfx_aatrns, p)
	end
	
	if testimonyprogress >= 3*TICRATE and testimonyprogress <= 7*TICRATE/2 then
		textpos = $+19
	elseif testimonyprogress < 12
		textpos = -320+testimonyprogress*27
	else
		textpos = 0
	end
	if barpos == 320 then
		barpos = 0
	else
		barpos = $+1
	end
	
	if testimonyprogress <= 7*TICRATE/2 then
		v.draw(textpos, 0, v.cachePatch("AAWITN"), 0, v.getColormap("sonic", testimcolor))
		v.draw(-textpos, 0, v.cachePatch("AATSTM"), 0, v.getColormap("sonic", testimcolor))
	elseif testimonyprogress <= 7*TICRATE/2+3*TICRATE then
		v.drawString(160, 100, "== "..testimtopic.." ==", V_ORANGEMAP, "thin-center")
	end
	if testimonyprogress >= 12 then
		v.draw(barpos, 0, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
		v.draw(-barpos, 188, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
		v.draw(-320+barpos, 0, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
		v.draw(320-barpos, 188, v.cachePatch("AATSTMB"), 0, v.getColormap("sonic", testimcolor))
	end
	if testimonyprogress <= 7*TICRATE/2+3*TICRATE then
		testimonyprogress = $+1
	end
end, "game")